'*****************************************************************************
'* apci57s.vb
'*
'* aPCI-A57Tv\[X
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'*
'*****************************************************************************

Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Public Class Form1
    Inherits System.Windows.Forms.Form

    Dim A57w As Apci57w

#Region " Windows tH[ fUCiŐꂽR[h "

    Public Sub New()
        MyBase.New()

        ' ̌Ăяo Windows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒɏǉ܂B

    End Sub

    ' Form ́AR|[lgꗗɌ㏈s邽߂ dispose I[o[Ch܂B
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows tH[ fUCiŕKvłB
    Private components As System.ComponentModel.IContainer

    '  : ȉ̃vV[ẂAWindows tH[ fUCiŕKvłB
    'Windows tH[ fUCigĕύXĂB  
    ' R[h GfB^gĕύXȂłB
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "aPCI-A57 Sample"

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim buf As String
        Dim dwDLLVer As Integer, dwDrvVer As Integer
        Dim wLogSlot As Short           ' foCXi[
        Dim Ri As Apci57w.Resource      ' \[X
        Dim Md As Apci57w.Mode          ' TvO[h
        Dim dwSwitchValue As Integer    ' [^XCb`̒l
        Dim dwNumData As Integer, dwStatus As Integer
        Dim wData() As Short
        Dim wDaData As Short                    ' D/Af[^
        Dim InValue As Byte, OutValue As Byte   ' PIOf[^
        Dim dwSts As Integer, vInitArg As Integer
        Dim i As Integer
        Dim bResult As Boolean

        ' 
        A57w = New Apci57w
        Md = New Apci57w.Mode
        Ri = New Apci57w.Resource
        Ri.dwMemBase = New Integer(Apci57w.MAX_MEM) {}
        Ri.dwMemLength = New Integer(Apci57w.MAX_MEM) {}
        Ri.dwMemAttrib = New Integer(Apci57w.MAX_MEM) {}
        Ri.dwIOPortBase = New Integer(Apci57w.MAX_IO) {}
        Ri.dwIOPortLength = New Integer(Apci57w.MAX_IO) {}
        Ri.dwIRQRegisters = New Integer(Apci57w.MAX_IRQ) {}
        Ri.dwIRQAttrib = New Integer(Apci57w.MAX_IRQ) {}
        Ri.dwDMALst = New Integer(Apci57w.MAX_DMA) {}
        Ri.dwDMAAttrib = New Integer(Apci57w.MAX_DMA) {}
        Ri.dwReserved1 = New Integer(Apci57w.MAX_RSV) {}

        ' 
        Ri.dwNumMemWindows = 0
        For i = 0 To Apci57w.MAX_MEM
            Ri.dwMemBase(i) = 0
            Ri.dwMemLength(i) = 0
            Ri.dwMemAttrib(i) = 0
        Next
        Ri.dwNumIOPorts = 0
        For i = 0 To Apci57w.MAX_IO
            Ri.dwIOPortBase(i) = 0
            Ri.dwIOPortLength(i) = 0
        Next
        Ri.dwNumIRQs = 0
        For i = 0 To Apci57w.MAX_IRQ
            Ri.dwIRQRegisters(i) = 0
            Ri.dwIRQAttrib(i) = 0
        Next
        Ri.dwNumDMAs = 0
        For i = 0 To Apci57w.MAX_DMA
            Ri.dwDMALst(i) = 0
            Ri.dwDMAAttrib(i) = 0
        Next
        For i = 0 To Apci57w.MAX_RSV
            Ri.dwReserved1(i) = 0
        Next

        '---------------------------------------------------------------------------
        ' o[Wԍ\
        ' aPCI-A57 DLL,Driver̃o[Wԍ擾
        If A57w.GetVersion(dwDLLVer, dwDrvVer) = False Then
            ErrorMessage(Apci57w.SLOT_AUTO)
            Exit Sub
        End If
        buf = String.Concat("GetVersion", vbCrLf, _
                            String.Format("DLL Version: &H{0:X8}", dwDLLVer), vbCrLf, _
                            String.Format("DRV Version: &H{0:X8}", dwDrvVer))
        ResultMessage(buf)

        '---------------------------------------------------------------------------
        ' aPCI-A57̎gp錾
        vInitArg = 0
        wLogSlot = Apci57w.SLOT_AUTO ' gp̃foCXT܂B
        bResult = A57w.Create(wLogSlot, 0, 0, vInitArg)
        If bResult = False Then  ' foCX܂B
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        buf = String.Concat("Created", vbCrLf, vbCrLf, _
                            String.Format("LogSlot: {0:d}", wLogSlot))
        ResultMessage(buf)

        '---------------------------------------------------------------------------
        ' \[X擾
        If A57w.GetResource(wLogSlot, Ri) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        '---------------------------------------------------------------------------
        ' [^XCb`̒l擾
        If A57w.GetSwitchValue(wLogSlot, dwSwitchValue) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        buf = String.Concat(String.Format("IO Address: &H{0:X4} - {1:X4}", _
                                            Ri.dwIOPortBase(0), _
                                            Ri.dwIOPortBase(0) + Ri.dwIOPortLength(0) - 1), vbCrLf, _
                            String.Format("IRQ: {0:d}", Ri.dwIRQRegisters(0)), vbCrLf, _
                            String.Format("SwitchValue: &H{0:X}", dwSwitchValue))
        ResultMessage(buf)

        '---------------------------------------------------------------------------
        '	A/D 
        '---------------------------------------------------------------------------
        ' TvO[h̐ݒ
        Md.dwChFirst = Apci57w.ADCH_01  ' TvOJn`l(0 ` 7)
        Md.dwChLast = Apci57w.ADCH_08   ' TvOI`l(0 ` 7)
        Md.cwBuffer = 256               ' obt@TCYi[hPʁj
        Md.dwTimer = &H15               ' ^C}l(&H15 = 500us)
        Md.dwMode = Apci57w.MODE_02     ' 샂[h(1`6)
        If A57w.SetMode(wLogSlot, Md) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        buf = String.Concat("Sampling Mode", vbCrLf, _
                            String.Format("TvOJn`l={0:d}", Md.dwChFirst), vbCrLf, _
                            String.Format("TvOI`l={0:d}", Md.dwChLast), vbCrLf, _
                            String.Format("obt@TCY={0:d}", Md.cwBuffer), vbCrLf, _
                            String.Format("^C}l=&H{0:X}", Md.dwTimer), vbCrLf, _
                            String.Format("샂[h={0:d}", Md.dwMode))
        ResultMessage(buf)

        '---------------------------------------------------------------------------
        ' TvOJn
        If A57w.StartSampling(wLogSlot) = False Then
            ErrorMessage(wLogSlot)
        End If
        ResultMessage("Sampling Started")

        '---------------------------------------------------------------------------
        ' BUFFER FULL܂BUFFER OVERFLOWɂȂ܂ő҂
        Do
            If A57w.GetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False Then
                ErrorMessage(wLogSlot)
                Exit Sub
            End If
            dwSts = dwStatus And (Apci57w.STS_BUFF_FULL Or Apci57w.STS_BUFF_OVERFLOW)
        Loop Until (dwSts <> 0)

        '---------------------------------------------------------------------------
        ' TvO~
        If A57w.StopSampling(wLogSlot) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        ResultMessage("Sampling Stopped")

        '---------------------------------------------------------------------------
        ' TvOEXe[^X̎擾
        If A57w.GetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        buf = String.Concat("TvOEXe[^X擾", vbCrLf, _
                            String.Format("f[^={0:d}", dwNumData), vbCrLf, _
                            String.Format("Xe[^X=&H{0:X}", dwStatus.ToString))
        ResultMessage(buf)

        '---------------------------------------------------------------------------
        ' TvOς݃f[^̎擾
        If dwNumData > 0 Then
            ReDim wData(dwNumData)
            If A57w.GetData(wLogSlot, dwNumData, wData(LBound(wData))) = False Then
                ErrorMessage(wLogSlot)
                Exit Sub
            End If

            If dwNumData > 100 Then ' f[^100ҏW甲悤ɂ
                dwNumData = 99
            End If

            buf = String.Concat("TvOς݃f[^擾", vbCrLf)
            For i = 0 To dwNumData
                buf = String.Concat(buf, String.Format("{0:d2} : 0x{1:X4}", _
                                                        i, wData(i)), vbTab)
                If (i + 1) Mod 4 = 0 Then ' 4 Ŋ؂
                    buf = String.Concat(buf, vbCrLf)
                End If
            Next i
            ResultMessage(buf)
        End If

        '---------------------------------------------------------------------------
        '   D/A 
        '---------------------------------------------------------------------------
        ' o̓f[^̐ݒ
        wDaData = &HFFF

        If A57w.SetData(wLogSlot, Apci57w.DACH_01, wDaData) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        buf = String.Concat("D/Af[^o", vbCrLf, _
                            String.Format("D/A Data: &H{0:X4}", wDaData))
        ResultMessage(buf)

        '--------------------------------------------------------------------------
        '	PIO 
        '--------------------------------------------------------------------------
        'Cӂ̃f[^o
        ' o̓f[^ AAh
        OutValue = &HAA

        If A57w.OutPort(wLogSlot, OutValue) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        buf = String.Concat("f[^o", vbCrLf, _
                            String.Format("Out Data: &H{0:X2}", OutValue))
        ResultMessage(buf)

        '---------------------------------------------------------------------------
        ' f[^ǂݍ
        InValue = &H0

        If A57w.InPort(wLogSlot, InValue) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        buf = String.Concat("f[^", vbCrLf, _
                            String.Format("In Data: &H{0:X2}", InValue))
        ResultMessage(buf)

        '---------------------------------------------------------------------------
        ' aPCI-A57̎gpJ
        If A57w.Close(wLogSlot) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        ResultMessage("Closed")
        Me.Close()
    End Sub

    '============================================================================
    '    ʂ\
    '============================================================================
    Private Sub ResultMessage(ByVal lpszbuf As String)
        MsgBox(lpszbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Information, Me.Text)
    End Sub

    '============================================================================
    '    G[bZ[W\
    '============================================================================
    Private Sub ErrorMessage(ByVal wLogSlot As Short)
        Dim dwRes As Integer
        Dim szBuf As String

        dwRes = A57w.GetLastError(wLogSlot)
        If dwRes = Apci57w.ERR_WRAPDLL Then
            dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error()
            szBuf = String.Concat("System error", vbCrLf, vbCrLf, _
                                    String.Format("Error code: &H{0:X8}", dwRes))
        Else
            szBuf = String.Concat("aPCI-A57 error", vbCrLf, vbCrLf, _
                                    String.Format("Error code: &H{0:X8}", dwRes))
        End If
        MsgBox(szBuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, Me.Text)
    End Sub

End Class
