'****************************************************************************
'*  apci57w.vb
'*
'*  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'****************************************************************************
Option Strict Off
Option Explicit On 

Imports System
Imports System.Runtime.InteropServices

Public Class Apci57w

    Private mErrWradll As Integer = SUCCESS   ' bp[֐G[

    ' őXbg
    Public Const MAX_SLOTS As Integer = 16

    ' _Xbgw
    Public Const SLOT_AUTO As Short = &HFFFFS

    ' G[R[h̒`
    Public Const SUCCESS As Integer = 0                ' I
    Public Const ERR_NO_DEVICE As Integer = 5000       ' No device or not an aPCI-A57
    Public Const ERR_RESOURCE As Integer = 5001        ' Resource exhaustion
    Public Const ERR_INVALID_ARG As Integer = 5002     ' Invalid argument(s)
    Public Const ERR_SLOT As Integer = 5003            ' _Xbgԍsłi܂͌܂j
    Public Const ERR_CHANNEL As Integer = 5004         ' `lw肪sł
    Public Const ERR_TIMER As Integer = 5005           ' ^C}lsł
    Public Const ERR_NOT_ENOUGH_MEM As Integer = 5006  ' \ȃmۂł܂ł
    Public Const ERR_NUMDATA As Integer = 5007         ' w肳ꂽ̃f[^obt@ɑ݂܂
    Public Const ERR_NOT_CREATED As Integer = 5008     ' foCXNGCgĂ܂
    Public Const ERR_START As Integer = 5009           ' X^[gɎs܂B
    Public Const ERR_INVALID_FUNC As Integer = 5010    ' Ȋ֐Ăяoł
    Public Const ERR_IN_USE As Integer = 5011          ' gp̃foCXł(NT)
    Public Const ERR_INTERNAL As Integer = 5100        ' Send mail to us
    Public Const ERR_UNKNOWN As Integer = 5101         ' Help me!
    Public Const ERR_WRAPDLL As Integer = -1           ' bp[֐G[

    ' TvO[h̒`
    '                                          START  SAMPLING  CLK   obt@[h
    Public Const MODE_01 As Integer = 1      ' soft   single    ---   hCo
    Public Const MODE_02 As Integer = 2      ' soft   burst     timer hCo
    Public Const MODE_03 As Integer = 3      ' extrg  single    ---   hCo
    Public Const MODE_04 As Integer = 4      ' extrg  burst     timer hCo
    Public Const MODE_05 As Integer = 5      ' soft   burst     timer foCX
    Public Const MODE_06 As Integer = 6      ' extrg  burst     timer foCX

    ' bZ[W
    ' Apci57Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
    ' ItZbglbZ[Wo܂B
    Public Const WM_EOC As Integer = 0                  ' VOTvO̊
    Public Const WM_BUFF_HALF_FULL As Integer = 1       ' hCoOobt@̃n[tt
    Public Const WM_BUFF_FULL As Integer = 2            ' hCoOobt@̃t
    Public Const WM_BUFF_OVERFLOW As Integer = 3        ' hCoOobt@̃I[o[t[
    Public Const WM_SAMPLING_OVERRUN As Integer = 4     ' `lEI[gECNg̃I[o[

    ' foCXXe[^XR[h
    Public Const STS_SAMPLING As Integer = &H1
    Public Const STS_EOC As Integer = &H2
    Public Const STS_BUFF_HALF_FULL As Integer = &H4
    Public Const STS_BUFF_FULL As Integer = &H8
    Public Const STS_BUFF_OVERFLOW As Integer = &H10
    Public Const STS_SAMPLING_OVERRUN As Integer = &H20

    ' A/D`lݒl͈̔
    Public Const ADCH_FIRST As Integer = 0
    Public Const ADCH_LAST As Integer = 7

    ' A/D`lݒl
    Public Const ADCH_01 As Integer = 0
    Public Const ADCH_02 As Integer = 1
    Public Const ADCH_03 As Integer = 2
    Public Const ADCH_04 As Integer = 3
    Public Const ADCH_05 As Integer = 4
    Public Const ADCH_06 As Integer = 5
    Public Const ADCH_07 As Integer = 6
    Public Const ADCH_08 As Integer = 7

    ' D/A`lݒl
    Public Const DACH_01 As Integer = 0
    Public Const DACH_02 As Integer = 1

    ' I/O\[XzE
    Public Const MIN_NUM As Integer = 0
    Public Const MAX_MEM As Integer = 9 - 1    ' MAX_MEM_REGISTERS
    Public Const MAX_IO As Integer = 20 - 1    ' MAX_IO_PORTS
    Public Const MAX_IRQ As Integer = 7 - 1    ' MAX_IRQS
    Public Const MAX_DMA As Integer = 7 - 1    ' MAX_DMA_CHANNELS
    Public Const MAX_RSV As Integer = 3 - 1

    'I/O\[X
    Structure Resource
        Dim dwNumMemWindows As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemBase() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemLength() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemAttrib() As Integer
        Dim dwNumIOPorts As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortBase() As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortLength() As Integer
        Dim dwNumIRQs As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQRegisters() As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQAttrib() As Integer
        Dim dwNumDMAs As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMALst() As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMAAttrib() As Integer
        <VBFixedArray(MAX_RSV), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_RSV + 1)> Dim dwReserved1() As Integer
    End Structure

    ' TvO[h
    Structure Mode
        Dim dwChFirst As Integer    ' TvOJn`l(0 ` 7)
        Dim dwChLast As Integer     ' TvOI`l(0 ` 7)
        Dim cwBuffer As Integer     ' obt@TCYi[hPʁj
        Dim dwTimer As Integer      ' ^C}l(00H ` 3FH)
        Dim dwMode As Integer       ' 샂[h(1 ` 6)
    End Structure

    ' API
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57GetVersion(ByRef pdwDllVer As Integer, _
                                            ByRef pdwDrvVer As Integer) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57Create(ByRef pwLogSlot As Short, _
                                            ByVal hWnd As Integer, _
                                            ByVal uWMBase As Integer, _
                                            ByRef pvInitArg As Integer) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57Close(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57GetResource(ByVal wLogSlot As Short, _
                                            ByRef pres As Resource) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57GetSwitchValue(ByVal wLogSlot As Short, _
                                            ByRef pdwSwitchValue As Integer) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57SetMode(ByVal wLogSlot As Short, _
                                            ByRef pcmode As Mode) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57StartSampling(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57StopSampling(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57GetSamplingStatus(ByVal wLogSlot As Short, _
                                            ByRef pcwNumData As Integer, _
                                            ByRef pdwStatus As Integer) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57GetData(ByVal wLogSlot As Short, _
                                            ByVal cwNumData As Integer, _
                                            ByRef pwData As Short) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57SetData(ByVal wLogSlot As Short, _
                                            ByVal wChData As Short, _
                                            ByVal wDaData As Short) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57InPort(ByVal wLogSlot As Short, _
                                            ByRef pbInValue As Byte) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57OutPort(ByVal wLogSlot As Short, _
                                            ByVal bOutValue As Byte) As Boolean
    End Function
    <DllImport("apci57.dll")> _
    Public Shared Function Apci57GetLastError(ByVal wLogSlot As Short) As Integer
    End Function

    '*****************************************************************************
    '*    aPCI-A57 DLL,Driver̃o[Wԍ擾
    '*    pdwDllVer DLLo[Wԍi[
    '*        pdwDrvVer Drivero[Wԍi[
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function GetVersion(ByRef pdwDllVer As Integer, _
                                        ByRef pdwDrvVer As Integer) As Boolean
        Try
            GetVersion = Apci57GetVersion(pdwDllVer, pdwDrvVer)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetVersion = False
        End Try
    End Function


    '*****************************************************************************
    '*    aPCI-A57̔Cӂ̃foCX̎gp錾
    '*    pwLogSlot gpfoCXi[AhX
    '*        hWnd      bZ[W𑗂EBhEnh
    '*        uWMBase   ƂȂ郁bZ[WID
    '*        pvInitArg gp(0Zbg)
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function Create(ByRef pwLogSlot As Short, _
                                            ByVal hWnd As Integer, _
                                            ByVal uWMBase As Integer, _
                                            ByRef pvInitArg As Integer) As Boolean
        Try
            Create = Apci57Create(pwLogSlot, hWnd, uWMBase, pvInitArg)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Create = False
        End Try
    End Function

    '*****************************************************************************
    '*    aPCI-A57̔Cӂ̃foCX̎gpJ
    '*    wLogSlot gpfoCX
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function Close(ByVal wLogSlot As Short) As Boolean
        Try
            Close = Apci57Close(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Close = False
        End Try
    End Function

    '*****************************************************************************
    '*    wfoCX̃\[X擾
    '*    wLogSlot ׂfoCX
    '*        pres     \[Xi[\
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function GetResource(ByVal wLogSlot As Short, _
                                            ByRef pres As Resource) As Boolean
        Try
            GetResource = Apci57GetResource(wLogSlot, pres)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetResource = False
        End Try
    End Function

    '*****************************************************************************
    '*    [^XCb`̒l擾
    '*    wLogSlot          ׂfoCX
    '*        pdwSwitchValue    [^XCb`̒l
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function GetSwitchValue(ByVal wLogSlot As Short, _
                                            ByRef pdwSwitchValue As Integer) As Boolean
        Try
            GetSwitchValue = Apci57GetSwitchValue(wLogSlot, pdwSwitchValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSwitchValue = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvO[h̐ݒ
    '*    wLogSlot ݒ肷foCX
    '*        pcmode   [hݒf[^̃AhX
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function SetMode(ByVal wLogSlot As Short, _
                                            ByRef pcmode As Mode) As Boolean
        Try
            SetMode = Apci57SetMode(wLogSlot, pcmode)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SetMode = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvOJn
    '*    wLogSlot JnfoCX
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function StartSampling(ByVal wLogSlot As Short) As Boolean
        Try
            StartSampling = Apci57StartSampling(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            StartSampling = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvO~
    '*    wLogSlot ~foCX
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function StopSampling(ByVal wLogSlot As Short) As Boolean
        Try
            StopSampling = Apci57StopSampling(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            StopSampling = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvOEXe[^X̎擾
    '*    wLogSlot   擾foCX
    '*        pcwNumData f[^obt@
    '*        pdwStatus  Xe[^X
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function GetSamplingStatus(ByVal wLogSlot As Short, _
                                            ByRef pcwNumData As Integer, _
                                            ByRef pdwStatus As Integer) As Boolean
        Try
            GetSamplingStatus = Apci57GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSamplingStatus = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvOς݃f[^̎擾
    '*    wLogSlot  擾foCX
    '*        cwNumData vf[^
    '*        pwData    f[^obt@
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function GetData(ByVal wLogSlot As Short, _
                                            ByVal cwNumData As Integer, _
                                            ByRef pwData As Short) As Boolean
        Try
            GetData = Apci57GetData(wLogSlot, cwNumData, pwData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetData = False
        End Try
    End Function

    '*****************************************************************************
    '*    D/Af[^̏o
    '*    wLogSlot  o͂foCX
    '*        wChData   ݃`lw
    '*        wDaData   o͂D/Af[^
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function SetData(ByVal wLogSlot As Short, _
                                            ByVal wChData As Short, _
                                            ByVal wDaData As Short) As Boolean
        Try
            SetData = Apci57SetData(wLogSlot, wChData, wDaData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SetData = False
        End Try
    End Function

    '*****************************************************************************
    '*    Cӂ̃|[gf[^
    '*    wLogSlot  ͂foCX
    '*        pbInValue ̓f[^i[AhX
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function InPort(ByVal wLogSlot As Short, _
                                            ByRef pbInValue As Byte) As Boolean
        Try
            InPort = Apci57InPort(wLogSlot, pbInValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            InPort = False
        End Try
    End Function

    '*****************************************************************************
    '*    Cӂ̃|[gփf[^o
    '*    wLogSlot  o͂foCX
    '*        bOutValue o͂f[^
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function OutPort(ByVal wLogSlot As Short, _
                                            ByVal bOutValue As Byte) As Boolean
        Try
            OutPort = Apci57OutPort(wLogSlot, bOutValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            OutPort = False
        End Try
    End Function

    '*****************************************************************************
    '*    aPCI-A57̃G[R[h
    '*    wLogSlot  G[foCX
    '* ߂l G[R[h
    '*****************************************************************************
    Public Function GetLastError(ByVal wLogSlot As Short) As Integer
        Try
            If mErrWradll = ERR_WRAPDLL Then    ' bp[֐G[Ȃ
                mErrWradll = SUCCESS            ' NA
                GetLastError = ERR_WRAPDLL
            Else
                GetLastError = Apci57GetLastError(wLogSlot)
            End If
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-A57 Error")
            GetLastError = ERR_WRAPDLL
            mErrWradll = SUCCESS            ' NA
        End Try
    End Function

End Class
