/*****************************************************************************/
/*	apci57w.h																 */
/*																			 */
/*	aPCI-A57															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*****************************************************************************/

#ifndef __INC_APCI57W_H__
#define __INC_APCI57W_H__

#include "apci57.h"


#ifdef __cplusplus
extern "C"{
#endif


#define APCI57_DLL_NAME	  _T("apci57.dll")	// DLL

#define APCI57_ERR_WRAPDLL ((DWORD)-1)	// bp[֐G[


BOOL  Apci57wDllOpen();		// DLL [h
BOOL  Apci57wDllClose();	// DLL A[h

BOOL  Apci57wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer);						// aPCI-A57 DLL,Driver̃o[Wԍ擾

BOOL  Apci57wCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg);		// CӂaPCI-A57̎gp錾
BOOL  Apci57wClose(WORD wLogSlot);													// CӂaPCI-A57̎gpJ

BOOL  Apci57wGetResource(WORD wLogSlot, PAPCI57R pres);								// \[X擾

BOOL  Apci57wGetSwitchValue(WORD wLOgSlot, PDWORD pdwSwitchValue);					// [^XCb`̒l擾

BOOL  Apci57wSetMode(WORD wLogSlot, PCAPCI57M pcmode);								// TvO[h̐ݒ
BOOL  Apci57wStartSampling(WORD wLogSlot);											// TvOJn
BOOL  Apci57wStopSampling(WORD wLogSlot);											// TvO~
BOOL  Apci57wGetSamplingStatus(WORD wLogSlot, PDWORD pcwNumData, PDWORD pdwStatus); // TvOEXe[^X̎擾
BOOL  Apci57wGetData(WORD wLogSlot, DWORD cwNumData, PWORD pwData);					// TvOς݃f[^̎擾

BOOL  Apci57wSetData(WORD wLogSlot, WORD wChData, WORD wDaData);					// D/Af[^̏o

BOOL  Apci57wInPort(WORD wLogSlot, PBYTE pbInValue);	// f[^
BOOL  Apci57wOutPort(WORD wLogSlot, BYTE bOutValue);	// f[^o

DWORD Apci57wGetLastError(WORD wLogSlot);											// aPCI-A57G[R[h


#ifdef __cplusplus
}
#endif

#endif // __INC_APCI57W_H__
