#ifndef _APCI57_H_
#define _APCI57_H_

#ifdef __cplusplus
extern "C" {
#endif

// őXbg
#define	APCI57_MAX_SLOTS				16

// _Xbgw
#define	APCI57_SLOT_AUTO				((WORD) ~0U)

// G[R[h̒`
#define	APCI57_ERR_INTERNAL				5100	// Send mail to us
#define	APCI57_ERR_UNKNOWN				5101	// Help me!
#define	APCI57_SUCCESS					0		// I
#define	APCI57_ERR_NO_DEVICE			5000	// No device or not an aPCI-A57
#define	APCI57_ERR_RESOURCE				5001	// Resource exhaustion
#define	APCI57_ERR_INVALID_ARG			5002	// Invalid argument(s)
#define	APCI57_ERR_SLOT					5003	// _Xbgԍsłi܂͌܂j
#define	APCI57_ERR_CHANNEL				5004	// `lw肪sł
#define	APCI57_ERR_TIMER				5005	// ^C}lsł
#define	APCI57_ERR_NOT_ENOUGH_MEM		5006	// \ȃmۂł܂ł
#define	APCI57_ERR_NUMDATA				5007	// w肳ꂽ̃f[^obt@ɑ݂܂
#define	APCI57_ERR_NOT_CREATED			5008	// foCXNGCgĂ܂
#define	APCI57_ERR_START				5009	// X^[gɎs܂B
#define	APCI57_ERR_INVALID_FUNC			5010	// Ȋ֐Ăяoł
#define	APCI57_ERR_IN_USE				5011	// gp̃foCXł(NT)
#define APCI57_ERR_FIFO					5012	// FIFOڂĂȂ

// TvO[h̒`
											// START  SAMPLING	CLK    obt@[h
#define	APCI57_MODE_01					1	// soft	  single	---    hCo
#define	APCI57_MODE_02					2	// soft	  burst		timer@hCo
#define	APCI57_MODE_03					3	// extrg  single	---@@hCo
#define	APCI57_MODE_04					4	// extrg  burst		timer@hCo
#define	APCI57_MODE_05					5	// soft	  burst		timer@foCX
#define	APCI57_MODE_06					6	// extrg  burst		timer@foCX

// bZ[W
// Apci57Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
// ItZbglbZ[Wo܂B
#ifndef WM_EOC
#define	WM_EOC						0		// VOTvO̊
#define	WM_BUFF_HALF_FULL			1		// hCoOobt@̃n[tt
#define	WM_BUFF_FULL				2		// hCoOobt@̃t
#define	WM_BUFF_OVERFLOW			3		// hCoOobt@̃I[o[t[
#define	WM_SAMPLING_OVERRUN			4		// `lEI[gECNg̃I[o[
#endif // WM_EOC

// foCXXe[^XR[h
#define APCI57_STS_SAMPLING				0x01
#define APCI57_STS_EOC					0x02
#define APCI57_STS_BUFF_HALF_FULL		0x04
#define APCI57_STS_BUFF_FULL			0x08
#define APCI57_STS_BUFF_OVERFLOW		0x10
#define APCI57_STS_SAMPLING_OVERRUN		0x20

// A/D`lݒl͈̔
#define APCI57_ADCH_FIRST			0
#define APCI57_ADCH_LAST			7

// A/D`lݒl
#define APCI57_ADCH_01				0
#define APCI57_ADCH_02				1
#define APCI57_ADCH_03				2
#define APCI57_ADCH_04				3
#define APCI57_ADCH_05				4
#define APCI57_ADCH_06				5
#define APCI57_ADCH_07				6
#define APCI57_ADCH_08				7

// D/A`lݒl
#define APCI57_DACH_01				0
#define APCI57_DACH_02				1

// I/O\[XzE
#define	APCI57_MAX_MEM				9	// MAX_MEM_REGISTERS
#define	APCI57_MAX_IO				20	// MAX_IO_PORTS
#define	APCI57_MAX_IRQ				7	// MAX_IRQS
#define	APCI57_MAX_DMA				7	// MAX_DMA_CHANNELS

// ***** I/O\[X\ *****
// YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B
typedef struct _APCI57RESOURCE
{
	DWORD	dwNumMemWindows;					// EBhE
	DWORD	dwMemBase[APCI57_MAX_MEM];			// EBhEJnAhX
	DWORD	dwMemLength[APCI57_MAX_MEM];		// EBhE
	DWORD	dwMemAttrib[APCI57_MAX_MEM];		// EBhE
	DWORD	dwNumIOPorts;						// I/O|[g
	DWORD	dwIOPortBase[APCI57_MAX_IO];		// I/O|[gJnAhX
	DWORD	dwIOPortLength[APCI57_MAX_IO];		// I/O|[g
	DWORD	dwNumIRQs;							// IRQ
	DWORD	dwIRQRegisters[APCI57_MAX_IRQ];		// IRQԍ
	DWORD	dwIRQAttrib[APCI57_MAX_IRQ];		// IRQ
	DWORD	dwNumDMAs;							// DMA`l
	DWORD	dwDMALst[APCI57_MAX_DMA];			// DMA`l
	DWORD	dwDMAAttrib[APCI57_MAX_DMA];		// DMA`l
	DWORD	dwReserved1[3];						// \
} APCI57RESOURCE, *PAPCI57R;


// ***** TvO[h\ *****
// YfoCX̃TvO[hɊւDriver֓n߂̍\́B
// iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB
typedef struct _APCI57MODE
{
	DWORD	dwChFirst;		// TvOJn`l(0 ` 7)
	DWORD	dwChLast;		// TvOI`l(0 ` 7)
	DWORD	cwBuffer;		// obt@TCYi[hPʁj
	DWORD	dwTimer;		// ^C}l(00H ` 3FH)
	DWORD	dwMode;			// 샂[h(1 ` 6)
} APCI57MODE, *PCAPCI57M;


// foCX̎gp錾
BOOL
WINAPI
Apci57Create(
	LPWORD		lpwLogSlot,				// _Xbgw
	HWND		hwnd,					// bZ[W󂯎EBhEnh
	UINT		uWMBase,				// bZ[WID̊l
	LPVOID		lpvInitArg);			// ̂߂̗\


// foCX̊J錾
BOOL
WINAPI
Apci57Close(
	WORD		wLogSlot);				// _Xbgw


// foCXhCoDLL̃o[W擾
BOOL
WINAPI
Apci57GetVersion(
	LPDWORD		lpdwDllVer,				// DLL̃o[W
	LPDWORD		lpdwDrvVer);			// Driver̃o[W


// I/O\[X̎擾
BOOL
WINAPI
Apci57GetResource(
	WORD		wLogSlot,				// _Xbg
	PAPCI57R	pres);					// \[X


// [^XCb`̒l擾
BOOL
WINAPI
Apci57GetSwitchValue(
	WORD		wLogSlot,				// _Xbg
	LPDWORD		lpdwSwitchValue);		// [^XCb`̒l

// G[R[h̎擾
DWORD
WINAPI
Apci57GetLastError(
	WORD		wLogSlot);				// _Xbg


// TvO[h̐ݒ
BOOL
WINAPI
Apci57SetMode(
	WORD		wLogSlot,				// _Xbg
	PCAPCI57M	pcmode);				// [hݒf[^


// TvOJn
BOOL
WINAPI
Apci57StartSampling(
	WORD		wLogSlot);				// _Xbg


// TvO~
BOOL
WINAPI
Apci57StopSampling(
	WORD		wLogSlot);				// _Xbg


// TvOEXe[^X̎擾
BOOL
WINAPI
Apci57GetSamplingStatus(
	WORD		wLogSlot,				// _Xbg
	LPDWORD		lpcwNumData,			// f[^obt@|C^
	LPDWORD		lpdwStatus);			// Xe[^X


// TvOς݃f[^̎擾
BOOL
WINAPI
Apci57GetData(
	WORD		wLogSlot,				// _Xbg
	DWORD		cwNumData,				// vf[^
	LPWORD		lpwData);				// f[^obt@ւ̃|C^


// D/Af[^̏o
BOOL
WINAPI
Apci57SetData(
	WORD		wLogSlot,				// _Xbg
	WORD		wChData,				// o̓`l
	WORD		wDaData);				// o̓f[^ւ̃|C^


// p
BOOL
WINAPI
Apci57InPort(
	WORD		wLogSlot,				// _Xbg
	LPBYTE		lpbInValue);			// p̓f[^ւ̃|C^


// po
BOOL
WINAPI
Apci57OutPort(
	WORD		wLogSlot,				// _Xbg
	BYTE		bOutValue);				// po̓f[^


#ifdef __cplusplus
}
#endif

#endif
