/*============================================================================
//	apci57s.h
//
//	aPCI-A57
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#pragma once

#include <windows.h>
#include "Apci57w.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;
using namespace System::Globalization; 

namespace SampleA57
{
	/// <summary> 
	/// Apci57s ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB 
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Apci57s : public System::Windows::Forms::Form
	{
	public: 
		Apci57s(void)
		{
			InitializeComponent();
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
        
	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container* components;

		static Apci57w* A57w;

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			// 
			// Apci57s
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(292, 273);
			this->Name = S"Apci57s";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"aPCI-A57 Sample";
			this->Load += new System::EventHandler(this, Apci57s_Load);

		}		
		private: System::Void Apci57s_Load(System::Object *  sender, System::EventArgs *  e)
		{
			String* buf;
			String* tmp;
			short wLogSlot;			// foCXi[
			Apci57w::Resource* Ri;	// \[X
			Apci57w::Mode* Md;		// TvO[h
			int dwDllVer, dwDrvVer;
			int dwSwitchValue;		// [^XCb`̒l
			int dwNumData, dwStatus;
			short* pwData;
			short wDaData;			// D/Af[^
			Byte InValue, OutValue;	// PIOf[^
			int dwSts, vInitArg;
			int i;
			bool bResult;

			A57w = new Apci57w;
			Md   = new Apci57w::Mode;
			Ri   = new Apci57w::Resource;
			Ri->dwMemBase		= new Int32[Apci57w::MAX_MEM];
			Ri->dwMemLength		= new Int32[Apci57w::MAX_MEM];
			Ri->dwMemAttrib		= new Int32[Apci57w::MAX_MEM];
			Ri->dwIOPortBase	= new Int32[Apci57w::MAX_IO];
			Ri->dwIOPortLength	= new Int32[Apci57w::MAX_IO];
			Ri->dwIRQRegisters	= new Int32[Apci57w::MAX_IRQ];
			Ri->dwIRQAttrib		= new Int32[Apci57w::MAX_IRQ];
			Ri->dwDMALst		= new Int32[Apci57w::MAX_DMA];
			Ri->dwDMAAttrib		= new Int32[Apci57w::MAX_DMA];
			Ri->dwReserved1		= new Int32[Apci57w::MAX_RSV];

			// 
			Ri->dwNumMemWindows = 0;
			for (i=0; i<Apci57w::MAX_MEM; i++) {
				Ri->dwMemBase[i]   = 0;
				Ri->dwMemLength[i] = 0;
				Ri->dwMemAttrib[i] = 0;
			}
			Ri->dwNumIOPorts = 0;
			for (i=0; i<Apci57w::MAX_IO; i++) {
				Ri->dwIOPortBase[i]   = 0;
				Ri->dwIOPortLength[i] = 0;
			}
			Ri->dwNumIRQs = 0;
			for (i=0; i<Apci57w::MAX_IRQ; i++) {
				Ri->dwIRQRegisters[i] = 0;
				Ri->dwIRQAttrib[i]    = 0;
			}
			Ri->dwNumDMAs = 0;
			for (i=0; i<Apci57w::MAX_DMA; i++) {
				Ri->dwDMALst[i]    = 0;
				Ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci57w::MAX_RSV; i++)
				Ri->dwReserved1[i] = 0;

			/*---------------------------------------------------------------------------*/
			// o[Wԍ\
			// aPCI-A57 DLL,Driver̃o[Wԍ擾
			if (A57w->GetVersion(&dwDllVer, &dwDrvVer) == false) {
				ErrorMessage(Apci57w::SLOT_AUTO);
				return;
			}
			buf = String::Concat(S"GetVersion\n",
									String::Format(S"DLL: 0x{0}\n", dwDllVer.ToString("x8")),
									String::Format(S"DRV: 0x{0}",   dwDrvVer.ToString("x8")));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// aPCI-A57̎gp錾
			vInitArg = 0;
			wLogSlot = Apci57w::SLOT_AUTO;		// gp̃foCXT܂B
			bResult = A57w->Create(&wLogSlot,	// ꍇA̎̃foCXi[܂B
									NULL,		// EBhEnhȂ̂NULLZbg܂B
												// EBhEnhZbg΁A
												// e탁bZ[W܂B
									0,			// 3ԖڂɃZbgẮAbZ[WID̊
												// ƂȂlłBۂ̃bZ[WID͂̊lɃI
												// tZbg(WM_EOCȂ)̂ƂȂ܂B
									NULL);
			if (bResult == false) {		// foCX܂B
				ErrorMessage(wLogSlot);
				return;
			}
			buf = String::Concat(S"Created\n\n",
									String::Format(S"LogSlot: {0}", wLogSlot.ToString("d")));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// \[X擾
			if (A57w->GetResource(wLogSlot, Ri) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			/*---------------------------------------------------------------------------*/
			// [^XCb`̒l擾
			if (A57w->GetSwitchValue(wLogSlot, &dwSwitchValue) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			buf = String::Concat(String::Format(S"IO Base Address  \t: 0x{0} - 0x{1}\n",
													Ri->dwIOPortBase[0].ToString("x4"),
													(Ri->dwIOPortBase[0] + Ri->dwIOPortLength[0] - 1).ToString("x4")),
									String::Format(S"IRQ         \t\t: {0}\n", 
													Ri->dwIRQRegisters[0].ToString("d")),
									String::Format(S"Switch      \t: 0x{0}",
													dwSwitchValue.ToString("x")));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------
			//	A/D 																	  
			//---------------------------------------------------------------------------*/
			// TvO[h̐ݒ
			Md->dwChFirst = Apci57w::ADCH_01;	// TvOJn`l(0 ` 7)
			Md->dwChLast  = Apci57w::ADCH_08;	// TvOI`l(0 ` 7)
			Md->cwBuffer  = 256;				// obt@TCYi[hPʁj
			Md->dwTimer   = 0x15;				// ^C}l(0x15 = 500us)
			Md->dwMode	   = Apci57w::MODE_02;	// 샂[h(1`6)
			if (A57w->SetMode(wLogSlot, Md) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			buf = String::Concat(S"Sampling Mode\n",
									String::Format(S"TvOJn`l={0}\n", 
													Md->dwChFirst.ToString("d")),
									String::Format(S"TvOI`l={0}\n", 
													Md->dwChLast.ToString("d")),
									String::Format(S"obt@TCY={0}\n", 
													Md->cwBuffer.ToString("d")),
									String::Format(S"^C}l=0x{0}\n", 
													Md->dwTimer.ToString("x")),
													String::Format(S"샂[h={0}", 
													Md->dwMode.ToString("d")));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// TvOJn
			if (A57w->StartSampling(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage(S"Sampling Started");

			/*---------------------------------------------------------------------------*/
			// BUFFER FULL܂BUFFER OVERFLOWɂȂ܂ő҂
			do {
				if (A57w->GetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == false) {
					ErrorMessage(wLogSlot);
					return;
				}
				dwSts = dwStatus & (Apci57w::STS_BUFF_FULL | Apci57w::STS_BUFF_OVERFLOW);
			} while (dwSts == 0);

			/*---------------------------------------------------------------------------*/
			// TvO~
			if (A57w->StopSampling(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage(S"Sampling Stopped");

			/*---------------------------------------------------------------------------*/
			// TvOEXe[^X̎擾
			if (A57w->GetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			buf = String::Concat(S"TvOEXe[^X擾\n",
									String::Format(S"f[^={0}\n", dwNumData.ToString("d")),
									String::Format(S"Xe[^X=0x{0}", dwStatus.ToString("x2")));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// TvOς݃f[^̎擾
			if (dwNumData > 0) {
				pwData = (short*)malloc(dwNumData * sizeof(short));
				if (pwData == NULL ) {
					ResultMessage(S"obt@mۂł܂ł");
					return;
				}
				if (A57w->GetData(wLogSlot, dwNumData, pwData) == false) {
					ErrorMessage(wLogSlot);
					return;
				}

				if (dwNumData > 100)
					dwNumData = 100;

					buf = "TvOς݃f[^擾\n";
					for (i = 0; i < dwNumData; i++) {
						tmp = String::Format(S"{0} : 0x{1}\t",
												i.ToString("d2"), pwData[i].ToString("X4"));
						buf = String::Concat(buf, tmp);
						if ((i + 1) % 4 == 0)	// 4 Ŋ؂
							buf = String::Concat(buf, S"\n");
					}
					ResultMessage(buf);
					free(pwData);
				}

				/*---------------------------------------------------------------------------
				//	D/A 
				//---------------------------------------------------------------------------*/
				// o̓f[^̐ݒ
				wDaData = 0x0FFF;

				if (A57w->SetData(wLogSlot, Apci57w::DACH_01, wDaData) == false) {
					ErrorMessage(wLogSlot);
					return;
				}

				buf = String::Concat(S"D/Af[^o\n",
										String::Format(S"D/A Data: 0x{0}", 
														wDaData.ToString("x4")));
				ResultMessage(buf);

				/*---------------------------------------------------------------------------
				//	PIO 
				//---------------------------------------------------------------------------*/
				// Cӂ̃f[^o
				// o̓f[^ AAh
				OutValue = 0xAA;

				if (A57w->OutPort(wLogSlot, OutValue) == false) {
					ErrorMessage(wLogSlot);
					return;
				}

				buf = String::Concat(S"f[^o\n",
										String::Format(S"Out Data: 0x{0}", 
														OutValue.ToString("x2")));
				ResultMessage(buf);

				/*---------------------------------------------------------------------------*/
				// f[^ǂݍ
				InValue = 0x00;

				if (A57w->InPort(wLogSlot, &InValue) == false) {
					ErrorMessage(wLogSlot);
					return;
				}

				buf = String::Concat(S"f[^\n",
										String::Format(S"In Data: 0x{0}", 
														InValue.ToString("x2")));
				ResultMessage(buf);

				/*---------------------------------------------------------------------------*/
				// aPCI-A57̎gpJ
				if (A57w->Close(wLogSlot) == false) {
					ErrorMessage(wLogSlot);
					return;
				}
				ResultMessage(S"Closed");
				this->Close();
			 }

		// ʂ\
		private: void ResultMessage(String* pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text, 
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		// װүނ\
		private: void ErrorMessage(short wLogSlot)
		{
			int dwRes = A57w->GetLastError(wLogSlot);
			String* szbuf;

			switch (dwRes) {
				case Apci57w::ERR_WRAPDLL:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szbuf = String::Concat(S"System error\n\n",
											String::Format(S"Error code: {0}", 
															dwRes.ToString("x8")));
					break;
				default:
					szbuf = String::Concat(S"aPCI-A57 error\n\n",
											String::Format(S"Error code: {0}", 
															dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(szbuf, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}
