Attribute VB_Name = "Sample"
'*****************************************************************************
'* apci57s.bas                                                               *
'*                                                                           *
'* aPCI-A57Tv\[X                                                    *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 2003/11/26                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szA57 = "aPCI-A57"
Private Declare Function GetLastError Lib "kernel32" () As Long

Sub Main()

    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim bResult As Boolean      ' 
    Dim wLogSlot As Integer     ' foCXi[
    Dim ri As APCI57RESOURCE    ' \[X
    Dim dwSwitchValue As Long   ' [^`XCb`̒l
    Dim md As APCI57MODE        ' TvO[h
    Dim dwNumData As Long
    Dim dwStatus As Long
    Dim wData() As Integer
    Dim wDaData As Integer      ' D/Af[^
    Dim InValue As Byte         ' PIOf[^
    Dim OutValue As Byte
    Dim i As Long

'---------------------------------------------------------------------------
    ' apci57.dll ̎gp錾
    If Apci57wDllOpen() = False Then
        ErrorMessage (APCI57_SLOT_AUTO)
        Exit Sub                ' apci57.dll ̃[hɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Apci57wGetVersion(dwDllVer, dwDrvVer) = False Then
        ErrorMessage (APCI57_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Driver Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aPCI-A57̎gp錾
    wLogSlot = APCI57_SLOT_AUTO     ' gp̃foCXT܂B

    ' ꍇA̎̃foCXi[܂B
    ' EBhEnhȂ̂ 0 Zbg܂B
    ' EBhEnhZbg΁Ae탁bZ[W܂B
    ' 3ԖڂɃZbgẮAbZ[WID̊ƂȂlłB
    ' ۂ̃bZ[WID͂̊lɃItZbg(WM_EOCȂ)̂ƂȂ܂B
    bResult = Apci57wCreate(wLogSlot, 0, &H700, 0)

    If bResult = False Then         ' foCX܂B
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "aPCI-A57 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Apci57wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

'---------------------------------------------------------------------------
    ' [^XCb`̒l擾
    If Apci57wGetSwitchValue(wLogSlot, dwSwitchValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szA57 + Chr(10) + _
             "IO Base Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1) + Chr(10) + _
             "IRQ: " + Str(ri.dwIRQRegisters(1)) + Chr(10) + _
                         "SwitchValue: &H" + Hex(dwSwitchValue)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
'  A/D 
'---------------------------------------------------------------------------
    ' TvO[h̐ݒ
    md.dwChFirst = 0            ' TvOJn`l(0 ` 7)
    md.dwChLast = 7             ' TvOI`l(0 ` 7)
    md.cwBuffer = 256           ' obt@TCYi[hPʁj
    md.dwTimer = &H15           ' ^C}l(&H15 = 500us)
    md.dwMode = APCI57_MODE_02  ' 샂[h(1`6)

    If Apci57wSetMode(wLogSlot, md) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "aPCI-A57 Sampling Mode" + Chr(10) + _
             "TvOJn`l=" + Str(md.dwChFirst) + Chr(10) + _
             "TvOI`l=" + Str(md.dwChLast) + Chr(10) + _
             "obt@TCY=" + Str(md.cwBuffer) + Chr(10) + _
             "^C}l=&H" + Hex(md.dwTimer) + Chr(10) + _
             "샂[h=" + Str(md.dwMode)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOJn
    If Apci57wStartSampling(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("aPCI-A57 Sampling Started")

'---------------------------------------------------------------------------
    ' APCI57_STS_BUFF_FULL܂APCI57_STS_BUFF_OVERFLOWɂȂ܂ő҂
    dwStatus = 0
    Do
        DoEvents
        If Apci57wGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False Then
            ErrorMessage (wLogSlot)
            Exit Sub
        End If
    Loop Until (dwStatus And (APCI57_STS_BUFF_FULL Or APCI57_STS_BUFF_OVERFLOW))
   
'---------------------------------------------------------------------------
    ' TvO~
    If Apci57wStopSampling(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("aPCI-A57 Sampling Stopped")

'---------------------------------------------------------------------------
    ' TvOEXe[^X̎擾
    If Apci57wGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "TvOEXe[^X擾" + Chr(10) + _
             "f[^=" + Str(dwNumData) + Chr(10) + _
             "Xe[^X=" + Str(dwStatus)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOς݃f[^̎擾
    If dwNumData > 0 Then
        ReDim wData(1 To dwNumData)

        If Apci57wGetData(wLogSlot, dwNumData, wData) = False Then
            ErrorMessage (wLogSlot)
            Exit Sub
        End If

        If dwNumData > 99 Then      ' f[^99ҏW甲悤ɂ
            dwNumData = 99
        End If

        strbuf = "TvOς݃f[^擾" + Chr(10)
        For i = 1 To dwNumData
            strbuf = strbuf + Str(i) + ":&H" + Hex(wData(i)) + "  "

            If (i + 1) Mod 4 = 0 Then   ' 4 Ŋ؂
                strbuf = strbuf + Chr(10)
            End If
        Next i

        ResultMessage (strbuf)
    End If

'---------------------------------------------------------------------------
'  D/A 
'---------------------------------------------------------------------------
    ' o̓f[^̐ݒ
    wDaData = &HFFF

    If Apci57wSetData(wLogSlot, APCI57_DACH_01, wDaData) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "D/Af[^o" + Chr(10) + _
             "D/A Data: &H" + Hex(wDaData)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
'  PIO 
'---------------------------------------------------------------------------
    ' Cӂ̃f[^o
    ' o̓f[^ AAh
    OutValue = &HAA

    If Apci57wOutPort(wLogSlot, OutValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "f[^o" + Chr(10) + _
             "Out Data: &H" + Hex(OutValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' f[^ǂݍ
    InValue = &H0

    If Apci57wInPort(wLogSlot, InValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "f[^" + Chr(10) + _
             "In Data: &H" + Hex(InValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aPCI-A57̎gpJ
    If Apci57wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("aPCI-A57 Closed")

'---------------------------------------------------------------------------
    ' apci57.dll ̎gpJ
    If Apci57wDllClose() = False Then
        MsgBox "DLL Unload error", vbOKOnly + vbCritical
        Exit Sub        ' apci57.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub

' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Apci57wGetLastError(wLogSlot)

    Select Case dwRes
    Case APCI57_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aPCI-A57 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
