Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* apci57w.bas                                                               *
'*                                                                           *
'* aPCI-A57                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 2003/11/26                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI57_DLL_NAME = "apci57.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const APCI57_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    apci57.dll[h                                                 *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wDllOpen() As Boolean

    Apci57wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(APCI57_DLL_NAME)
    If hDLL = 0 Then Exit Function

    If Apci57wGetDllExportFunc() = False Then
        Apci57wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Apci57wDllOpen = True

End Function

'*****************************************************************************
'*    apci57.dllA[h                                             *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wDllClose() As Boolean

    Apci57wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Apci57wDllClose = False

End Function

'*****************************************************************************
'*    aPCI-A57 DLL,Driver̃o[Wԍ擾                            *
'*    pdwDllVer DLLo[Wԍi[                                  *
'*        pdwDrvVer Drivero[Wԍi[                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean

    Apci57wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Apci57GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function

    Apci57wGetVersion = True

End Function

'*****************************************************************************
'*    aPCI-A57̔Cӂ̃foCX̎gp錾                               *
'*    pwLogSlot gpfoCXi[AhX                       *
'*        hWnd      bZ[W𑗂EBhEnh                       *
'*        uWMBase   ƂȂ郁bZ[WID                                   *
'*        pvInitArg gp(0Zbg)                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wCreate(ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Long) As Boolean

    Apci57wCreate = False

    If hDLL = 0 Then Exit Function

    If Apci57Create(pwLogSlot, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function

    Apci57wCreate = True

End Function

'*****************************************************************************
'*    aPCI-A57̔Cӂ̃foCX̎gpJ                               *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wClose(ByVal wLogSlot As Integer) As Boolean

    Apci57wClose = False

    If hDLL = 0 Then Exit Function

    If Apci57Close(wLogSlot) = 0 Then Exit Function

    Apci57wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pres     \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wGetResource(ByVal wLogSlot As Integer, ByRef pres As APCI57RESOURCE) As Boolean

    Apci57wGetResource = False

    If hDLL = 0 Then Exit Function

    If Apci57GetResource(wLogSlot, pres) = 0 Then Exit Function

    Apci57wGetResource = True

End Function

'*****************************************************************************
'*    [^XCb`̒l擾                                         *
'*    wLogSlot              ׂfoCX                               *
'*        pdwSwitchValue        [^XCb`̒l                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wGetSwitchValue(ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Boolean

    Apci57wGetSwitchValue = False

    If hDLL = 0 Then Exit Function

    If Apci57GetSwitchValue(wLogSlot, pdwSwitchValue) = 0 Then Exit Function

    Apci57wGetSwitchValue = True

End Function

'*****************************************************************************
'*    TvO[h̐ݒ                                           *
'*    wLogSlot ݒ肷foCX                                          *
'*        pcmode   [hݒf[^̃AhX                                *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wSetMode(ByVal wLogSlot As Integer, ByRef pcmode As APCI57MODE) As Boolean

    Apci57wSetMode = False

    If hDLL = 0 Then Exit Function

    If Apci57SetMode(wLogSlot, pcmode) = 0 Then Exit Function

    Apci57wSetMode = True

End Function

'*****************************************************************************
'*    TvOJn                                                   *
'*    wLogSlot JnfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wStartSampling(ByVal wLogSlot As Integer) As Boolean

    Apci57wStartSampling = False

    If hDLL = 0 Then Exit Function

    If Apci57StartSampling(wLogSlot) = 0 Then Exit Function

    Apci57wStartSampling = True

End Function

'*****************************************************************************
'*    TvO~                                                   *
'*    wLogSlot ~foCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wStopSampling(ByVal wLogSlot As Integer) As Boolean

    Apci57wStopSampling = False

    If hDLL = 0 Then Exit Function

    If Apci57StopSampling(wLogSlot) = 0 Then Exit Function

    Apci57wStopSampling = True

End Function

'*****************************************************************************
'*    TvOEXe[^X̎擾                                     *
'*    wLogSlot   擾foCX                                        *
'*        pcwNumData f[^obt@                                        *
'*        pdwStatus  Xe[^X                                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wGetSamplingStatus(ByVal wLogSlot As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Boolean

    Apci57wGetSamplingStatus = False

    If hDLL = 0 Then Exit Function

    If Apci57GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus) = 0 Then Exit Function

    Apci57wGetSamplingStatus = True

End Function

'*****************************************************************************
'*    TvOς݃f[^̎擾                                       *
'*    wLogSlot  擾foCX                                         *
'*        cwNumData vf[^                                             *
'*        pwData    f[^obt@                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wGetData(ByVal wLogSlot As Integer, ByVal cwNumData As Long, ByRef pwData() As Integer) As Boolean

    Apci57wGetData = False

    If hDLL = 0 Then Exit Function

    If Apci57GetData(wLogSlot, cwNumData, pwData(LBound(pwData))) = 0 Then Exit Function

    Apci57wGetData = True

End Function

'*****************************************************************************
'*    D/Af[^̏o                                                    *
'*    wLogSlot  o͂foCX                                         *
'*        wChData   ݃`lw                                   *
'*        wDaData   o͂D/Af[^                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wSetData(ByVal wLogSlot As Integer, ByVal wChData As Integer, ByVal wDaData As Integer) As Boolean
    
    Apci57wSetData = False
    
    If hDLL = 0 Then Exit Function

    If Apci57SetData(wLogSlot, wChData, wDaData) = 0 Then Exit Function

    Apci57wSetData = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gf[^                                       *
'*    wLogSlot  ͂foCX                                         *
'*        pbInValue ̓f[^i[AhX                             *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wInPort(ByVal wLogSlot As Integer, ByRef pbInValue As Byte) As Boolean

    Apci57wInPort = False
    
    If hDLL = 0 Then Exit Function

    If Apci57InPort(wLogSlot, pbInValue) = 0 Then Exit Function

    Apci57wInPort = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gփf[^o                                         *
'*    wLogSlot  o͂foCX                                         *
'*        bOutValue o͂f[^                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci57wOutPort(ByVal wLogSlot As Integer, ByVal bOutValue As Byte) As Boolean

    Apci57wOutPort = False
    
    If hDLL = 0 Then Exit Function

    If Apci57OutPort(wLogSlot, bOutValue) = 0 Then Exit Function

    Apci57wOutPort = True

End Function

'*****************************************************************************
'*    aPCI-A57̃G[R[h                                             *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Apci57wGetLastError(ByVal wLogSlot As Integer) As Long

    Apci57wGetLastError = APCI57_ERR_WRAPDLL

    If hDLL = 0 Then Exit Function

    Apci57wGetLastError = Apci57GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Apci57wGetDllExportFunc() As Boolean

    Dim pFunc As Long

    Apci57wGetDllExportFunc = False

    ' Apci57GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57GetVersion")
    If pFunc = 0 Then Exit Function

    ' Apci57Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57Create")
    If pFunc = 0 Then Exit Function

    ' Apci57Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57Close")
    If pFunc = 0 Then Exit Function

    ' Apci57GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57GetResource")
    If pFunc = 0 Then Exit Function

        ' Apci57GetSwitchValueAhX擾
    pFunc = GetProcAddress(hDLL, "Apci57GetSwitchValue")
    If pFunc = 0 Then Exit Function

    ' Apci57SetMode ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57SetMode")
    If pFunc = 0 Then Exit Function

    ' Apci57StartSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57StartSampling")
    If pFunc = 0 Then Exit Function

    ' Apci57StopSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57StopSampling")
    If pFunc = 0 Then Exit Function

    ' Apci57GetSamplingStatus ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57GetSamplingStatus")
    If pFunc = 0 Then Exit Function

    ' Apci57GetData ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57GetData")
    If pFunc = 0 Then Exit Function

    ' Apci57SetData ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57SetData")
    If pFunc = 0 Then Exit Function

    ' Apci57InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57InPort")
    If pFunc = 0 Then Exit Function

    ' Apci57OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57OutPort")
    If pFunc = 0 Then Exit Function

    ' Apci57GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci57GetLastError")
    If pFunc = 0 Then Exit Function

    Apci57wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
